#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#define RTP_HEADER_LEN 12
typedef int64_t mtime_t;
struct block_t {
    struct block_t    *p_next;
    struct block_t    *p_prev;

    uint32_t    i_flags;

    
    mtime_t     i_pts;
    mtime_t     i_dts;
    mtime_t     i_length;

    int         i_samples; /* Used for audio */
    int         i_rate;

    int         i_buffer;
    uint8_t     *p_buffer;
};


struct access_sys_t
{
   // int fd;

   // int i_mtu;
   // vlc_bool_t b_auto_mtu;

    /* reorder rtp packets when out-of-sequence */
    mtime_t i_rtp_late;
    uint16_t i_last_seqno;
    struct    block_t *p_list;
    struct block_t *p_end;
    int    buffer;
};



struct block{
        int64_t i_start;        /* Offset of block for p_first */
        int     i_offset;       /* Offset for data in p_current */
        struct block_t *p_current;     /* Current block */

        int     i_size;         /* Total amount of data in the list */
        struct block_t *p_first;
        struct block_t **pp_last;

    };


struct block_t* BlockUDP(int);
struct block_t* block_New(void);
struct block_t *BlockPrebufferRTP( int, struct access_sys_t *, struct block_t * );
int    rtp_ChainInsert( struct access_sys_t* , struct block_t *);
void BlockParseRTP( struct block_t * );
struct block_t *BlockRTP( struct access_sys_t*, int);
mtime_t mdate(void);

int main()
{
    
   int choice=0;
   int fd;  
   struct sockaddr_in addr;
   int i_opt;
   int i_mtu = 1500;
   struct block_t* b;
   struct block_t* c;
   struct block* b1;
   struct access_sys_t* p_sys;
   FILE*  pFile;
 
   p_sys->buffer=0;
   while( (choice != 1) && (choice != 2)){
   printf("Please enter 1 for unicast reception and 2 for multicast reception\n");
   scanf("%d", &choice);
   }
       
   pFile = fopen( "out2.ts", "ab");   
   if (choice == 1)    
   {
       fd = socket(AF_INET, SOCK_DGRAM, 0);
       memset(&addr, 0, sizeof(addr));
       addr.sin_addr.s_addr = htonl(INADDR_ANY);
       addr.sin_port = htons(1234);
       bind( fd , (struct sockaddr *)&addr, sizeof( addr ) );
       i_opt = 1;
       setsockopt( fd, SOL_SOCKET, SO_REUSEADDR, (void *) &i_opt,
                    sizeof( i_opt ) );  
      /* i_opt=0x80000;
       setsockopt( fd, SOL_SOCKET, SO_RCVBUF, (void *) &i_opt,
                    sizeof( i_opt ) ) ; 
       */
       i_opt=1;
      if( setsockopt( fd, SOL_SOCKET, SO_BROADCAST, (void*) &i_opt,
                        sizeof( i_opt ) )== -1)
          printf("error in establishment\n");
      // shutdown( fd, SHUT_WR );
   }

   if(choice == 2)
   {
       fd = socket(AF_INET, SOCK_DGRAM, 0);
       memset(&addr, 0, sizeof(addr));
       addr.sin_addr.s_addr = inet_addr("239.255.42.42");
       addr.sin_port = htons(1234);
       bind( fd , (struct sockaddr *)&addr, sizeof( addr ) );
        
       struct ip_mreq imr;

       imr.imr_interface.s_addr = INADDR_ANY;
       imr.imr_multiaddr.s_addr = addr.sin_addr.s_addr;
       
       i_opt = 1;
       setsockopt( fd, SOL_SOCKET, SO_REUSEADDR, (void *) &i_opt,
                    sizeof( i_opt ) );
       setsockopt( fd, IPPROTO_IP, IP_ADD_MEMBERSHIP,
                            (char*)&imr, sizeof(struct ip_mreq) );         
   }   

   
       int     i_rtp_version;
       int     i_CSRC_count;
       int     i_payload_type;
       

     p_sys->i_rtp_late = 100000;
     p_sys->i_last_seqno = 0;
     p_sys->p_list = NULL;
     p_sys->p_end = NULL;


          
       b =  BlockUDP(fd); 
       if(b== NULL)
       printf("Something wrong\n");
    printf("Successful return from function call\n");
    i_rtp_version  = ( b->p_buffer[0] & 0xC0 ) >> 6;
    
    i_CSRC_count   = ( b->p_buffer[0] & 0x0F );
    i_payload_type = ( b->p_buffer[1] & 0x7F );

       if( b->p_buffer[0] == 0x47 )
       {
        printf("detected TS over raw UDP\n" );
                 
          while( b )
          {
            /* Append the block */
            b1->i_size += b->i_buffer;
            *b1->pp_last = b;
            b1->pp_last = &b->p_next;

            //p_sys->stat.i_read_count++;
            b = b->p_next;
          }
          
          for( ; ; )
          {
             b = BlockUDP(fd);
          
          while( b )
          {
            /* Append the block */
            b1->i_size += b->i_buffer;
            *b1->pp_last = b;
            b1->pp_last = &b->p_next;

            //p_sys->stat.i_read_count++;
            b = b->p_next;
          }              
          }
        }  
 
        /*
        p_access->pf_block = BlockUDP;
        p_access->info.b_prebuffered = VLC_TRUE;
        return p_block;
        */
        //}
        
    /*if( p_block->i_buffer < RTP_HEADER_LEN )
        return p_block;
    */ 
    /* Parse the header and make some verifications.
     * See RFC 3550. */



    else if ( i_rtp_version != 2 )
    {
        printf( "no supported RTP header detected\n" );
         while( b )
          {
            /* Append the block */
            b1->i_size += b->i_buffer;
            *b1->pp_last = b;
            b1->pp_last = &b->p_next;

            //p_sys->stat.i_read_count++;
            b = b->p_next;
          }
          
          for( ; ; )
          {
             b = BlockUDP(fd);
          
          while( b )
          {
            /* Append the block */
            b1->i_size += b->i_buffer;
            *b1->pp_last = b;
            b1->pp_last = &b->p_next;

            //p_sys->stat.i_read_count++;
            b = b->p_next;
          }              
          }
  


  /*    p_access->pf_block = BlockUDP;
        p_access->info.b_prebuffered = VLC_TRUE;
        return p_block;
    */
    }
    else if( i_payload_type == 33 )
    {
        
            printf("detected TS over RTP\n" );
            
           BlockParseRTP(b);
            
           

          c=  BlockPrebufferRTP( fd, p_sys, b); 
          while( c )
          {
            /* Append the block */
            fwrite (c->p_buffer , sizeof(uint8_t) , sizeof(c->p_buffer) , pFile );
            b1->i_size += c->i_buffer;
            *b1->pp_last = c;
            b1->pp_last = &c->p_next;

            //p_sys->stat.i_read_count++;
            b = b->p_next;
          }   
           
          c = BlockRTP(p_sys, fd);
                    while( c )
          {
            /* Append the block */
            b1->i_size += c->i_buffer;
            *b1->pp_last = c;
            b1->pp_last = &c->p_next;

            //p_sys->stat.i_read_count++;
            b = b->p_next;
          }   
     }   
     else 
     {    /*   
            p_access->psz_demux = strdup( "ts" );
            break;

        case 14:
            msg_Dbg( p_access, "detected MPEG audio over RTP" );
            p_access->psz_demux = strdup( "mpga" );
            break;

        case 32:
            msg_Dbg( p_access, "detected MPEG video over RTP" );
            p_access->psz_demux = strdup( "mpgv" );
            break;
        */
   
       
            printf("no RTP header detected\n" );
            while( b )
          {
            /* Append the block */
            b1->i_size += b->i_buffer;
            *b1->pp_last = b;
            b1->pp_last = &b->p_next;

            //p_sys->stat.i_read_count++;
            b = b->p_next;
          }
          
          for( ; ; )
          {
             b = BlockUDP(fd);
          
          while( b )
          {
            /* Append the block */
            b1->i_size += b->i_buffer;
            *b1->pp_last = b;
            b1->pp_last = &b->p_next;

            //p_sys->stat.i_read_count++;
            b = b->p_next;
          }              
          }
            /* p_access->pf_block = BlockUDP;
            p_access->info.b_prebuffered = VLC_TRUE;
            return p_block;
            */
     }

    


    



  return 0;
}


struct block_t *BlockUDP(int fd)
{
    
    struct block_t      *p_block;
    int i_mtu = 15;
    /* Read data */
    p_block = block_New();

    printf("Successful return fro block_New\n");
    //const int i_alloc = i_size + 2 * BLOCK_PADDING_SIZE + 16;
    
   // p_block->i_buffer = net_Read( p_access, p_sys->fd, NULL,
   //                               p_block->p_buffer, p_sys->i_mtu,
   //                               VLC_FALSE );
   
     p_block->i_buffer = recv(fd, p_block->p_buffer, i_mtu, 0 ) ;
     if(p_block->i_buffer == -1)
        printf("Something wrong with recv\n");
        printf("Successful return from recv\n");
    
   /* if( p_block->i_buffer <= 0 )
    {
        block_Release( p_block );
        return NULL;
    }
*/
    /*
    if( (p_block->i_buffer >= i_mtu) 
        && i_mtu < 32767 )
    {
       i_mtu*= 2;
    } 
       /* Increase by 100% */
    /*    p_sys->i_mtu *= 2;
        msg_Dbg( p_access, "increasing MTU to %d", p_sys->i_mtu );
    }
    */   
    return p_block;
}

struct block_t* block_New()
{
    
    //block_sys_t *p_sys;
    uint8_t * p_allocated_buffer;
    const int i_alloc = 1500 + 2 *32 + 16;
    struct block_t *p_block =
        malloc( sizeof(struct block_t ) + i_alloc );

    //if( p_block == NULL ) return NULL;

    

    /* Fill all fields */
    p_block->p_next         = NULL;
    p_block->p_prev         = NULL;
    p_block->i_flags        = 0;
    p_block->i_pts          = 0;
    p_block->i_dts          = 0;
    p_block->i_length       = 0;
    p_block->i_rate         = 0;
    p_block->i_buffer       = 1500;
    p_block->p_buffer       = malloc((1500 + 2*32 + 16)*(sizeof(uint8_t)));
   
    return p_block;
}

void BlockParseRTP( struct block_t *p_block )
{
    int      i_rtp_version;
    int      i_CSRC_count;
    int      i_payload_type;
    int      i_skip = 0;
    int      i_extension_flag = 0;
    int      i_extension_length = 0;
    uint16_t i_sequence_number = 0;
    
   
   
    if( p_block->i_buffer < RTP_HEADER_LEN )
        goto trash;

    /* Parse the header and make some verifications.
     * See RFC 3550. */
    i_rtp_version     = ( p_block->p_buffer[0] & 0xC0 ) >> 6;
    i_CSRC_count      = p_block->p_buffer[0] & 0x0F;
    i_extension_flag  = p_block->p_buffer[0] & 0x10;
    i_payload_type    = p_block->p_buffer[1] & 0x7F;
    i_sequence_number = (p_block->p_buffer[2] << 8 ) + p_block->p_buffer[3];

    if( i_rtp_version != 2 )
        printf("RTP version is %u, should be 2\n", i_rtp_version );

    if( i_payload_type == 14 || i_payload_type == 32)
        i_skip = 4;
    else if( i_payload_type !=  33 )
        printf("unsupported RTP payload type (%u)\n", i_payload_type );
    if( i_extension_flag )
        i_extension_length = 4 +
            4 * ( (p_block->p_buffer[14] << 8) + p_block->p_buffer[15] );

    /* Skip header + CSRC extension field n*(32 bits) + extension */
    i_skip += RTP_HEADER_LEN + 4*i_CSRC_count + i_extension_length;

    if( i_skip >= p_block->i_buffer )
        goto trash;

    /* Return the packet without the RTP header, remember seqno in i_dts */
    p_block->i_buffer -= i_skip;
    if(!p_block)
     printf("error\n");   
    p_block->p_buffer += i_skip;
    if(! p_block)
     printf("error\n");
    p_block->i_pts = mdate();
    if(!p_block)
      printf("error\n");
    p_block->i_dts = (mtime_t) i_sequence_number;
    if(!p_block)
      printf("error\n");


  //  return p_block;


trash:
    printf( "received a too short packet for RTP\n" );
   // block_Release( p_block );
   // return NULL;
}


mtime_t mdate( void )
{


    struct timeval tv_date;

    /* gettimeofday() could return an error, and should be tested. However, the
     * only possible error, according to 'man', is EFAULT, which can not happen
     * here, since tv is a local variable. */
    gettimeofday( &tv_date, NULL );
    return( (mtime_t) tv_date.tv_sec * 1000000 + (mtime_t) tv_date.tv_usec );


}


struct block_t *BlockPrebufferRTP( int fd, struct access_sys_t *p_sys, struct block_t *p_block )
{
    //access_sys_t *p_sys = p_access->p_sys;
    mtime_t   i_first = mdate();
    int       i_count = 0;
    struct block_t   *p = p_block;

    for( ;; )
    {
        mtime_t i_date = mdate();

        if( p && rtp_ChainInsert( p_sys, p ))
            i_count++;

        /* Require at least 2 packets in the buffer */
        if( i_count > 2 && (i_date - i_first) > p_sys->i_rtp_late )
            break;
        p = BlockUDP(fd);
        BlockParseRTP(p);
        if( !p && (i_date - i_first) > p_sys->i_rtp_late ) 
        {
            printf( "error in RTP prebuffering!\n" );
            break;
        }
    }

    printf("RTP: prebuffered %d packets\n", i_count - 1 );
    p_sys->buffer = 1;
    p = p_sys->p_list;
    p_sys->p_list = p_sys->p_list->p_next;
    p_sys->i_last_seqno = (uint16_t) p->i_dts;
    p->p_next = NULL;
    return p;
}

struct block_t *BlockRTP( struct access_sys_t* p_sys, int fd )
{
    //access_sys_t *p_sys = p_access->p_sys;
    struct block_t *p;

    while ( !p_sys->p_list || 
             ( mdate() - p_sys->p_list->i_pts ) < p_sys->i_rtp_late )
    {
       

         p = BlockUDP(fd);  
         BlockParseRTP(p);

        if ( !p ) 
            return NULL;

        rtp_ChainInsert( p_sys, p );
    }

    p = p_sys->p_list;
    p_sys->p_list = p_sys->p_list->p_next;
    p_sys->i_last_seqno++;
    if( p_sys->i_last_seqno != (uint16_t) p->i_dts )
    {
        printf("RTP: packet(s) lost, expected %d, got %d\n",
                 p_sys->i_last_seqno, (uint16_t) p->i_dts );
        p_sys->i_last_seqno = (uint16_t) p->i_dts;
    }
    p->p_next = NULL;
    return p;
}

/*
 * rtp_ChainInsert - insert a p_block in the chain and
 * look at the sequence numbers.
 */
int  rtp_ChainInsert( struct access_sys_t* p_sys, struct block_t *p_block)
{
    
    struct block_t *p_prev = NULL;
    struct block_t *p = p_sys->p_end;
    uint16_t i_new = (uint16_t) p_block->i_dts;
    uint16_t i_tmp = 0;

    if( !p_sys->p_list )
    {
        p_sys->p_list = p_block;
        p_sys->p_end = p_block;
        return 1;
    }
    /* walk through the queue from top down since the new packet is in 
    most cases just appended to the end */

    for( ;; )
    {
        i_tmp = i_new - (uint16_t) p->i_dts;

        if( !i_tmp )   /* trash duplicate */
            break; 

        if ( i_tmp < 32768 )
        {   /* insert after this block ( i_new > p->i_dts ) */
            p_block->p_next = p->p_next;
            p->p_next = p_block;
            p_block->p_prev = p;
            if (p_prev)
            {
                p_prev->p_prev = p_block;
                printf("RTP reordering: insert after %d, new %d\n", 
                    (uint16_t) p->i_dts, i_new );
            }
            else 
            {
                p_sys->p_end = p_block;
            }
            return 1;
        }
        if( p == p_sys->p_list )
        {   /* we've reached bottom of chain */
            i_tmp = p_sys->i_last_seqno - i_new;
            if( !p_sys->buffer || (i_tmp > 32767) )
            {
                printf("RTP reordering: prepend %d before %d\n", 
                        i_new, (uint16_t) p->i_dts );
                p_block->p_next = p;
                p->p_prev = p_block;
                p_sys->p_list = p_block;
                return 1;
            }

            if( !i_tmp )   /* trash duplicate */
                break;    

            /* reordering failed - append the packet to the end of queue */
            printf("RTP: sequence changed (or buffer too small) "
                "new: %d, buffer %d...%d\n", i_new, (uint16_t) p->i_dts, 
                (uint16_t) p_sys->p_end->i_dts);
            p_sys->p_end->p_next = p_block;
            p_block->p_prev = p_sys->p_end;
            p_sys->p_end = p_block;
            return 1;
        }
        p_prev = p;
        p = p->p_prev;
    }
    //block_Release( p_block );
    return 0;
}


